From 3b7f7a559f35f47187071def6f892796011dea8b Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:29:46 +0000
Subject: [PATCH 2/17] Refactors queue.py module.


  - Add a new decorator to check when a queue is empty.
  - Create subpackage to unit tests.
  - Change Queues methods to static methods.

---

diff --git a/kiskadee/fetchers/example.py b/kiskadee/fetchers/example.py
index 02eb9b2..a4c1593 100644
--- a/kiskadee/fetchers/example.py
+++ b/kiskadee/fetchers/example.py
@@ -9,7 +9,8 @@ class Fetcher(kiskadee.fetchers.Fetcher):
         """Use sources from test suite."""
         return 'kiskadee/tests/test_source/test_source.tar.gz'
 
-    def watch(self, **kwargs):
+    @kiskadee.queue.enqueue_project
+    def watch(self):
         """There is no proper API to inspect new example versions.
         It should not matter, since example will not receive updates.
         """
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index ef3fb77..fbf68bc 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -53,9 +53,32 @@ class Monitor:
             if pkg:
                 self._send_to_runner(pkg)
             time.sleep(2)
-            analyzed_project = self.kiskadee_queue.dequeue_result()
+            analyzed_project = self.queues.dequeue_result()
             self._save_analyzed_project(analyzed_project)
 
+    def dequeue_package(self):
+        """Dequeue packages from packages_queue."""
+        if not kiskadee.queue.packages_queue.empty():
+            pkg = kiskadee.queue.packages_queue.get()
+            kiskadee.logger.debug(
+                    "MONITOR: Dequed Package: {}_{}"
+                    .format(pkg["name"], pkg["version"])
+                )
+            return pkg
+        return {}
+
+    # Use directly dequeue_result from kiskadee.queue
+    #def dequeue_result(self):
+    #    """Dequeue analyzed packages from result_queue."""
+    #    if not self.kiskadee_queue.results_empty():
+    #        pkg = self.kiskadee_queue.dequeue_result()
+    #        kiskadee.logger.debug(
+    #                "MONITOR: Dequed result for package : {}-{}"
+    #                .format(pkg["name"], pkg["version"])
+    #            )
+    #        return pkg
+    #    return {}
+
     def _send_to_runner(self, pkg):
         _name = pkg['fetcher'].split('.')[-1]
         _fetcher = self._query(Fetcher).filter_by(name = _name).first()
@@ -80,8 +103,8 @@ class Monitor:
                     self.kiskadee_queue.enqueue_analysis(pkg)
 
     # Move this to model.py
-    def _save_analyzed_project(self, data):
-        if not data:
+    def _save_analyzed_project(self, project):
+        if not pkg:
             return {}
         project = self._query(Package).filter_by(name = data['name']).first()
         if not project:
@@ -93,7 +116,7 @@ class Monitor:
             self._save_analysis(data, analyzer, result, project.versions[-1])
 
     # Move this to model.py
-    def _update_project(self, package, pkg):
+    def _update_pkg(self, package, pkg):
 
         if(package.versions[-1].number == pkg['version']):
             return package
@@ -115,7 +138,7 @@ class Monitor:
             return None
 
     # Move this to model.py
-    def _save_project(self, pkg):
+    def _save_pkg(self, pkg):
         homepage = None
         if ('meta' in pkg) and ('homepage' in pkg['meta']):
             homepage = pkg['meta']['homepage']
@@ -230,11 +253,11 @@ def daemon():
     runner = Runner()
     monitor_process = Process(
             target=monitor.monitor,
-            args=(queues,)
+            args=(queues)
         )
     runner_process = Process(
             target=runner.runner,
-            args=(queues,)
+            args=(queues)
         )
     monitor_process.start()
     runner_process.start()
diff --git a/kiskadee/queue.py b/kiskadee/queue.py
index 214b631..a6835ea 100644
--- a/kiskadee/queue.py
+++ b/kiskadee/queue.py
@@ -1,6 +1,5 @@
 """Provide kiskadee queues and operations on them."""
 import time
-import dill
 from multiprocessing import Queue
 
 import kiskadee
@@ -24,10 +23,10 @@ def enqueue_project(fetcher_watch):
     """
     def wrapper(*args, **kwargs):
         project = fetcher_watch(*args, **kwargs)
-        kiskadee.queue.queues.enqueue_project(project)
+        kiskadee.queue.Queues.enqueue_project(project)
         fetcher = project['fetcher'].name
         kiskadee.logger.debug(
-                "{} fetcher: sending package {}_{} for monitor"
+                "{} fetcher: Sending package {}_{} for monitor"
                 .format(fetcher, package['name'], package['version'])
             )
         time.sleep(2)
@@ -41,14 +40,15 @@ class Queues():
     """Provide kiskadee queues objects."""
 
     @staticmethod
-    def enqueue_analysis(project_to_analysis):
+    def enqueue_analysis(analysis):
         """Put a analysis on the analysis queue."""
-        analysis.put(project_to_analysis)
+        analysis.put(analysis)
 
     @staticmethod
+    @empty_queue
     def dequeue_analysis():
         """Get a analysis from the analysis queue."""
-        return analysis.get()
+        return analysis.get(timeout=1)
 
     @staticmethod
     def enqueue_result(result):

